/*
  Petr Janoušek
  Pro ČVUT FEL - Kurz Praktické Elektroniky 2020
  31.08.2020
  Tento program ukazuje funkci Digitalního výstupního pinu a zápis do něho. LEDka by měla blikat.
*/
#include "mbed.h"

DigitalOut led(PA_4); //nastaví pin PA_4 jako digitální výstupní a nepřesně řečeno jej pojmenuje "led", což nám do budoucna usnadní orientaci v programu a jeho případnou úpravu
                          // pokud budeme chtít ovládat tento pin, stačí napsat jeho jméno (led) a nemusíme tak znovu dohledávat jeho pin (PA_4)
                          // název pinu a jeho pozici najdeme v DataSheetu příslušného mikrořadiče (https://embedded.fel.cvut.cz/sites/default/files/kurzy/kurz_prakticke_elektroniky/Informace/en.DM00105814___DS10147_STM32F042_Data.pdf str 31.)

int main()
{     
        while(1) {                  //nekonečná smyčka
            led.write(0);       //nastaví napětí na pinu led_pin (PA_4) na logickou nulu, tedy 0V. Přestože se intuitivně nabízí, že 0=zhasnuto, opak je v tomto případě pravdou. 
                                    //Uvědomme si, že Dioda je v tomto případě neustále připojená na napětí a my procesorkem uzemňujeme její druhý vývod - nula jej tedy uzemnila a Dioda svítí. 
                                    //Temuto invertujícímu jevu je možné se vyhnout - pokud by LED byla neustále připojena na zem a my procesorkem připojovali kladné napětí.
            //led_pin=0;            //ekvivalentní zápis řádku číslo 16, je však kratší
            wait(1);                //počká 1s
            led_pin.write(1);       //nastaví napětí na pinu led_pin (PA_4) na logickou jedničku, v našem případě 5V. Dioda nesvítí.
            wait(1);                //počká 1s
            
           }
}
