/*
  Petr Janoušek
  Pro ČVUT FEL - Kurz Praktické Elektroniky 2020
  31.08.2020
  Tento program ukazuje funkci digitálního výstupního i vstupního pinu a práci s nimi. Na zmáčknutí tlačítka by měla LEDka reagovat změnou frekvence blikání.
*/
#include "mbed.h"

DigitalOut led(PA_4);    // nastaví pin na který je připojena LED na digitální výstupní 
DigitalIn button(PA_3); // nastaví pin PA_3 jako digitální vstup

int main()
{
    button.mode(PullUp);          //zapne na pinu button (PA_3) vnitřní pullUp resistor. Pokud není vstupní pin připojený(když není tlačítko sepnuté), může se stát, 
                                  //že čtená hodnota na pinu bude "plavat", v podstatě bude hodnota kmitat mezi 1 a 0 podle různých vnějších rušení
                                  //(např. doteky prstů nebo přítomnost jiných elektrických zařízení v okolí) tento jev je pochopitelně nežádaný. 
                                  //PullUp resistor tedy zajistí, že při nesepnutém tlačítku bude na pinu logická 1. Pokusně si vyzkoušejte zakomentovat tento řádek a sledujte jaký to má vliv na chování LEDky. 
                                  //pokud by vás pullDown a pullUp resistory zajímaly víc, vaši starší kolegové vám určitě rádi zodpoví všechny otázky
    while(1) {                      
        if(button.read()==0)      //přečte stav na pinu button (PA_3) a pokud je roven logické 0(tlačítko je stisknuté), bliká s frekventí 2.5 Hz
            {
                led.write(0);       // zapíše na pin led (PA_4) logickou nulu
                wait(0.2);
                led.write(1);       // zapíše na pin led (PA_4) logickou jedničku
                wait(0.2);  }    
        else                      //pokud NENÍ stav na pinu button roven logické jedničce (tlačítko je stisknuté), bliká s frekventí 0.5 Hz, tedy pomaleji
            {
                led.write(0);      // zapíše na pin led (PA_4) logickou nulu
                wait(1);            
                led.write(1);      // zapíše na pin led (PA_4) logickou jedničku
                wait(1);    }
        //všimneme si, že trvá poměrně dlouho než procesorek zareaguje na zmačknuté tlačíko (než se změní rychlost blikání LEDky) to je způsobeno funkcemi Wait() v našem kódu. 
        //Pokud zmačkneme tlačítko například v momentě kdy je program na řádku č. 28 bude reakce trvat přes 2 sekundy - vykonají se řádky 28-31, pak program skoří znovu na řádek 20 a až tam si díky funkci button.read() všimne, že je tlačítko zmáčknuté
        //Ovládání pomocí tlačítek se v reálu řeší trochu jinak(pro zájemce - přerušení), ale pro ukázku čtení stavu na pinu to považuji za dostačující a názorné
    }
}