/*
  Petr Janoušek
  Pro ČVUT FEL - Kurz Praktické Elektroniky 2020
  31.08.2020
  Tento ptogram ukazuje funkci PWM - postupnou změnou střídy se mění jas LEDky. Nastavuje se perioda PWM na 6 ms a 100 periodách (tedy 600ms nebo 0.6 s) se mění střída
  Pro snažší chápání doporučuji přepojit LEDku tak, aby anoda byla na přes resistor (např 470 Ohm) na pin PA_4 a katoda na zem, jinak je průběh inverzní a matoucí.
*/



#include "mbed.h"

 DigitalOut led(PA_4); //nastaví pin PA_4 jako digitální výstup
 
 int main() 
    { 
    float duty=0;           // založí proměnou "duty" typu float - česky střída. Udává poměr (časový) logické jedničky a logické nuly na výstupu. Je-li duty=1 je na výstupu pouze logická jednička. 
                            // Je-li duty = 0.5 je na výstupu půlku času logická nula a druhou půlku logická jednička atd. Pokud je střídání logických hodnot dostatečně rychlé, zařízení, které je pulzy 
                            // napájeno je nebude stíhat vnímat jako pulzy, a začne je vidět jako konstantní hodnotu napětí nižší hodnoty.  Bližší detaily jsou poměrně snadno googlitelné, proto je zde nebudu vypisovat.
    float period=0.006;     // založí proměnou typu float
    int i=0;                // pomocná proměnná
    while(1) 
        { 
        led.write(1);       // zapíše logickou 1
        wait(period*duty);  // počká - mějme příklad: Period=1 a duty=0.3. Chceme tedy, aby 30% periody (tedy 0.3s) byl signál roven 1 a 70% periody (tedy 0.7s) roven 0 -> toho dosáhneme právě vynásobením periody a střídy
        led.write(0);       // zapíše logickou 0
        i++;                // přičte k proměnné i jedničku
        if(i>=100)          // pokud program probehl 100x dojde k automatickému zvýšení střídy O 20% -> jas ledky vzroste
             {
             i=0;
             duty=duty+0.2; //zvýšení střídy o 20% -> zvýšení jasu
             }
        if(duty>=1)         //pokud je střída větší než 1, což z principu věci nedává smysl, je její hodnota změněna na nulu 
            {
            duty=0;
            }     
        wait(period*(1-duty));  //počká po požadovanou dobu, kdy je pin nastaven na logickou nulu
        }
    }
    
//PWM se v reálných případech generuje hardwarově, tak aby nezatěžovala samotný běh procesoru. Pokud bychom totiž chtěli, aby procesor dělal i jiné věci, docházelo by k deformacím výstupního PWM signálu. 
//V Mbed jsou pro PWM přímo integrované funkce (pracující s hardwarem), ze kterých však není princip PWM příliš zřejmý.
